VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsFileSearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const c_FileSize = "###,###,###,###,###,###,##0"
Private Const c_FileCount = "###,###,###,##0"

Private Const MAXDWORD As Long = &HFFFF
Private Const MAX_PATH As Long = 260
Private Const INVALID_HANDLE_VALUE As Long = -1
Private Const FILE_ATTRIBUTE_ARCHIVE As Long = &H20
Private Const FILE_ATTRIBUTE_COMPRESSED As Long = &H800
Private Const FILE_ATTRIBUTE_DIRECTORY As Long = &H10
Private Const FILE_ATTRIBUTE_HIDDEN As Long = &H2
Private Const FILE_ATTRIBUTE_NORMAL As Long = &H80
Private Const FILE_ATTRIBUTE_READONLY As Long = &H1
Private Const FILE_ATTRIBUTE_TEMPORARY As Long = &H100
Private Const FILE_ATTRIBUTE_FLAGS = FILE_ATTRIBUTE_ARCHIVE Or _
                                    FILE_ATTRIBUTE_HIDDEN Or _
                                    FILE_ATTRIBUTE_NORMAL Or _
                                    FILE_ATTRIBUTE_READONLY

Private Const DRIVE_UNKNOWNTYPE As Long = 1
Private Const DRIVE_REMOVABLE As Long = 2
Private Const DRIVE_FIXED As Long = 3
Private Const DRIVE_REMOTE As Long = 4
Private Const DRIVE_CDROM As Long = 5
Private Const DRIVE_RAMDISK As Long = 6

Private Type FILETIME
   dwLowDateTime As Long
   dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
   dwFileAttributes As Long
   ftCreationTime As FILETIME
   ftLastAccessTime As FILETIME
   ftLastWriteTime As FILETIME
   nFileSizeHigh As Long
   nFileSizeLow As Long
   dwReserved0 As Long
   dwReserved1 As Long
   cFileName As String * MAX_PATH
   cAlternate As String * 14
End Type

Private Type FILE_PARAMS
   bRecurse As Boolean     'set True to perform a recursive search
   bList As Boolean        'set True to add results to listbox
   bFound As Boolean       'set only with SearchTreeForFile methods
   sFileRoot As String     'search starting point, ie c:\, c:\winnt\
   sFileNameExt As String  'filename/filespec to locate, ie *.dll, notepad.exe
   sResult As String       'path to file. Set only with SearchTreeForFile methods
   nFileCount As Long      'total file count matching filespec. Set in FindXXX only
   nFileSize As Double     'total file size matching filespec. Set in FindXXX only
End Type

Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function SearchTreeForFile Lib "imagehlp.dll" (ByVal sFileRoot As String, ByVal InputPathName As String, ByVal OutputPathBuffer As String) As Boolean
Private Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long

Private m_FileList As Variant
Private m_Cancel As Boolean
Private m_FP As FILE_PARAMS

Private Function QualifyPath(sPath As String) As String

  'assures that a passed path ends in a slash
  
   If Right$(sPath, 1) <> "\" Then
         QualifyPath = sPath & "\"
   Else: QualifyPath = sPath
   End If
      
End Function

Private Function IsArrayEmpty(tArray As Variant, Optional Dimension As Integer = 1) As Boolean
    On Local Error GoTo ReportError
    
    IsArrayEmpty = Not IsNumeric(UBound(tArray, Dimension))
    Exit Function
    
ReportError:
    IsArrayEmpty = True
    Exit Function
End Function

Private Function StripItem(startStrg As String) As String

  'Take a string separated by Chr(0)'s,
  'and split off 1 item, and shorten the
  'string so that the next item is ready
  'for removal.
   Dim pos As Integer
   
   pos = InStr(startStrg, Chr$(0))
   
   If pos Then
      StripItem = Mid(startStrg, 1, pos - 1)
      startStrg = Mid(startStrg, pos + 1, Len(startStrg))
   End If
   
End Function

Private Function TrimNull(startstr As String) As String

  'returns the string up to the first
  'null, if present, or the passed string
   Dim pos As Integer
   
   pos = InStr(startstr, Chr$(0))
   
   If pos Then
      TrimNull = Left$(startstr, pos - 1)
      Exit Function
   End If
  
   TrimNull = startstr
  
End Function

Public Function GetFileInformation() As Long

  'local working variables
   Dim WFD As WIN32_FIND_DATA
   Dim hFile As Long
   Dim nSize As Long
   Dim sPath As String
   Dim sRoot As String
   Dim sTmp As String
  
  'FP.sFileRoot (assigned to sRoot) contains
  'the path to search.
  '
  'FP.sFileNameExt (assigned to sPath) contains
  'the full path and filespec.
   sRoot = QualifyPath(m_FP.sFileRoot)
   sPath = sRoot & m_FP.sFileNameExt
   
  'obtain handle to the first filespec match
   hFile = FindFirstFile(sPath, WFD)
   
  'if valid ...
   If hFile <> INVALID_HANDLE_VALUE Then

      Do
      
        DoEvents
        If m_Cancel Then
            GoTo EndFunction
        End If
        'remove trailing nulls
         sTmp = TrimNull(WFD.cFileName)
         
        'Even though this routine uses filespecs,
        '*.* is still valid and will cause the search
        'to return folders as well as files, so a
        'check against folders is still required.
         If Not (WFD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) _
            = FILE_ATTRIBUTE_DIRECTORY Then
      
           'file found, so increase the file count
            m_FP.nFileCount = m_FP.nFileCount + 1
            
           'retrieve the size and assign to nSize to
           'be returned at the end of this function call
            nSize = nSize + (WFD.nFileSizeHigh * (MAXDWORD + 1)) + WFD.nFileSizeLow
            
           'add to the list if the flag indicates
            If m_FP.bList Then
               If IsArrayEmpty(m_FileList) Then
                    ReDim m_FileList(0)
                    m_FileList(0) = sRoot & sTmp
                Else
                    ReDim Preserve m_FileList(UBound(m_FileList) + 1)
                    m_FileList(UBound(m_FileList)) = sRoot & sTmp
               End If
            End If
         
         End If
         
      Loop While FindNextFile(hFile, WFD)
      
      
     'close the handle
      hFile = FindClose(hFile)
   
   End If
   
  'return the size of files found
   GetFileInformation = nSize
   Exit Function
   
EndFunction:
    hFile = FindClose(hFile)
    GetFileInformation = nSize
    Exit Function
End Function

Public Function SearchPathForFile() As Boolean
  
   Dim sResult As String
   
  'pad a return string and search the passed drive
   sResult = Space(MAX_PATH)

  'SearchTreeForFile returns True (1) if found,
  'or False otherwise. If True, sResult holds
  'the full path.
   m_FP.bFound = SearchTreeForFile(m_FP.sFileRoot, m_FP.sFileNameExt, sResult)
       
  'if found, strip the trailing nulls and exit
      If m_FP.bFound Then
      m_FP.sResult = LCase$(TrimNull(sResult))
   End If
    
   SearchPathForFile = m_FP.bFound
    
End Function

Public Function SearchSystemForFile() As Boolean

   Dim nSize As Long
   Dim sBuffer As String
   Dim currDrive As String
   Dim sResult As String
       
  'retrieve the available drives on the system
   sBuffer = Space$(64)
   nSize = GetLogicalDriveStrings(Len(sBuffer), sBuffer)
   
  'nSize returns the size of the drive string
   If nSize Then
   
     'strip off trailing nulls
      sBuffer = Left$(sBuffer, nSize)
     
     'search each fixed disk drive for the file
      Do Until sBuffer = ""

        DoEvents
        If m_Cancel Then
            GoTo EndFunction
        End If
        'strip off one drive item from sBuffer
         m_FP.sFileRoot = StripItem(sBuffer)

        'just search the local file system
         If GetDriveType(m_FP.sFileRoot) = DRIVE_FIXED Then
         
           'this may take a while, so update the
           'display when the search path changes
           'pad a return string and search the passed drive
            sResult = Space(MAX_PATH)
      
            m_FP.bFound = SearchTreeForFile(m_FP.sFileRoot, m_FP.sFileNameExt, sResult)
            
           'if found, strip the trailing nulls and exit
            If m_FP.bFound Then
               m_FP.sResult = LCase$(TrimNull(sResult))
               Exit Do
            End If
         
         End If
      
      Loop
      
   End If
      
   SearchSystemForFile = m_FP.bFound
   Exit Function
   
EndFunction:
   SearchSystemForFile = m_FP.bFound
   Exit Function
End Function

Public Function SearchForFiles() As Double

  'local working variables
   Dim WFD As WIN32_FIND_DATA
   Dim hFile As Long
   Dim nSize As Double
   Dim sPath As String
   Dim sRoot As String
   Dim sTmp As String
      
   sRoot = QualifyPath(m_FP.sFileRoot)
   sPath = sRoot & "*.*"
   
  'obtain handle to the first match
   hFile = FindFirstFile(sPath, WFD)
   
  'if valid ...
   If hFile <> INVALID_HANDLE_VALUE Then
     'This is where the method obtains the file
     'list and data for the folder passed.
     '
     'GetFileInformation function returns the size,
     'in bytes, of the files found matching the
     'filespec in the passed folder, so its
     'assigned to nSize. It is not directly assigned
     'to FP.nFileSize because nSize is incremented
     'below if a recursive search was specified.
      nSize = GetFileInformation()
      m_FP.nFileSize = nSize

      Do
      
        DoEvents
        If m_Cancel Then
            GoTo EndFunction
        End If
        'if the returned item is a folder...
         If (WFD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) Then
            
           '..and the Recurse flag was specified
            If m_FP.bRecurse Then
            
              'remove trailing nulls
               sTmp = TrimNull(WFD.cFileName)
               
              'and if the folder is not the default
              'self and parent folders...
               If sTmp <> "." And sTmp <> ".." Then
               
                 '..then the item is a real folder, which
                 'may contain other sub folders, so assign
                 'the new folder name to FP.sFileRoot and
                 'recursively call this function again with
                 'the ammended information.
                 '
                 'Since nSize is a local variable, whose value
                 'is both set above as well as returned as the
                 'function call value, the nSize needs to be
                 'added to previous calls in order to maintain accuracy.
                 '
                 'However, because the nFileSize member of
                 'FILE_PARAMS is passed back and forth through
                 'the calls, nSize is simply assigned to it
                 'after the recursive call finishes.
                  m_FP.sFileRoot = sRoot & sTmp
                  nSize = nSize + SearchForFiles()
                  m_FP.nFileSize = nSize
                  
               End If
               
            End If
            
         End If
         
     'continue looping until FindNextFile returns
     '0 (no more matches)
      Loop While FindNextFile(hFile, WFD)
      
     'close the find handle
      hFile = FindClose(hFile)
   
   End If
   
  'because this routine is recursive, return
  'the size of matching files
   SearchForFiles = nSize
   Exit Function
   
EndFunction:
    hFile = FindClose(hFile)
    SearchForFiles = nSize
    Exit Function
End Function

Public Function SearchForFolders() As Long

   Dim WFD As WIN32_FIND_DATA
   Dim hFile As Long
   Dim sRoot As String
   Dim sPath As String
   Dim sTmp As String
   Dim nCount As Long
   
   sRoot = QualifyPath(m_FP.sFileRoot)
   sPath = sRoot & m_FP.sFileNameExt
   
  'obtain handle to the first match
   hFile = FindFirstFile(sPath, WFD)
   
  'if valid ...
   If hFile <> INVALID_HANDLE_VALUE Then
         
      Do
         
        DoEvents
        If m_Cancel Then
            GoTo EndFunction
        End If
        'We only want folders in this method.
         If (WFD.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) Then
         
           'remove trailing nulls
            sTmp = TrimNull(WFD.cFileName)
         
           'and if not the default system folders
            If sTmp <> "." And sTmp <> ".." Then
            
              'count it and add to the list if the flag indicates
               nCount = nCount + 1
                If m_FP.bList Then
                   If IsArrayEmpty(m_FileList) Then
                        ReDim m_FileList(0)
                        m_FileList(0) = sRoot & sTmp
                    Else
                        ReDim Preserve m_FileList(UBound(m_FileList) + 1)
                        m_FileList(UBound(m_FileList)) = sRoot & sTmp
                   End If
                End If
            
              'if a recursive search was selected, call
              'this method again with a modified root
               If m_FP.bRecurse Then
               
                  m_FP.sFileRoot = sRoot & sTmp
                  nCount = nCount + SearchForFolders
                  
               End If
               
              'this is outside the recurse code in case
              'a single path-search was specified
               m_FP.nFileCount = nCount
               
            End If
         End If
         
      Loop While FindNextFile(hFile, WFD)
      
     'close the handle
      hFile = FindClose(hFile)
   
   End If

  'since folders are 0-length, return the count instead
   SearchForFolders = nCount
   Exit Function
   
EndFunction:
    hFile = FindClose(hFile)
    SearchForFolders = nCount
    Exit Function
End Function

Public Property Get FileList() As Variant
    FileList = m_FileList
End Property

Public Property Let Cancel(bNewValue As Boolean)
    m_Cancel = bNewValue
End Property

Public Property Get Recurse() As Boolean
    Recurse = m_FP.bRecurse
End Property

Public Property Let Recurse(bNewValue As Boolean)
    m_FP.bRecurse = bNewValue
End Property

Public Property Get List() As Boolean
    List = m_FP.bList
End Property

Public Property Let List(bNewValue As Boolean)
    m_FP.bList = bNewValue
End Property

Public Property Get Found() As Boolean
    Found = m_FP.bFound
End Property

Public Property Let Found(bNewValue As Boolean)
    m_FP.bFound = bNewValue
End Property

Public Property Get FileRoot() As String
    FileRoot = m_FP.sFileRoot
End Property

Public Property Let FileRoot(sNewValue As String)
    m_FP.sFileRoot = sNewValue
End Property

Public Property Get FileNameExtension() As String
    FileNameExtension = m_FP.sFileNameExt
End Property

Public Property Let FileNameExtension(sNewValue As String)
    m_FP.sFileNameExt = sNewValue
End Property

Public Property Get Result() As String
    Result = m_FP.sResult
End Property

Public Property Let Result(sNewValue As String)
    m_FP.sResult = sNewValue
End Property

Public Property Get FileCount() As Long
    FileCount = m_FP.nFileCount
End Property

Public Property Let FileCount(lNewValue As Long)
    m_FP.nFileCount = lNewValue
End Property

Public Property Get FileSize() As Double
    FileSize = m_FP.nFileSize
End Property

Public Property Let FileSize(dNewValue As Double)
    m_FP.nFileSize = dNewValue
End Property

Public Property Get FormatFileSize() As String
    FormatFileSize = c_FileSize
End Property

Public Property Get FormatFileCount() As String
    FormatFileCount = c_FileCount
End Property

