VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPackFiles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum WipeType
    [Quick] = 0
    [Government]
End Enum

Private m_FileList As Variant
Private m_TargetFile As String
Private m_TargetPath As String
Private m_UseOriginalPath As Boolean
Private m_BufferArray As Variant
Private m_ChunkSize As Double
Private m_CompressFiles As Boolean
Private m_VerifyFiles As Boolean
Private m_DeleteFiles As Boolean
Private m_WipeFiles As Boolean
Private m_WipeMethod As WipeType
Private m_PackFileContents As Variant

Event FileProgress(sngPercentage As Integer)
Event TotalFileProgress(sngPercentage As Integer)
Event ProcessingFile(FileName As String)

Private Type BNode
    DictIdx As Long
    pLeft As Long
    pRight As Long
End Type
    
Private Dict(4096) As String
Private NextDictIdx As Long
Private Heap(4096) As BNode
Private NextHeapIdx As Long
Private pStr As Long

Private Sub InitDict()
    Dim i As Integer
    
    For i = 0 To 255
        Dict(i) = Chr(i)
    Next i
    
    NextDictIdx = 256
    NextHeapIdx = 0
End Sub

Private Sub RmTree(ByVal vDir As Variant)
    Dim vFile As Variant
    
    If Right(vDir, 1) = "\" Then
        vDir = Left(vDir, Len(vDir) - 1)
    End If
    
    vFile = Dir(vDir & "\", vbDirectory)
    Do Until vFile = ""
        If vFile = "." Or vFile = ".." Then
            vFile = Dir
        ElseIf (GetAttr(vDir & "\" & vFile) And _
            vbDirectory) = vbDirectory Then
            RmTree vDir & "\" & vFile
            vFile = Dir(vDir & "\", vbDirectory)
        Else
            Kill vDir & "\" & vFile
            vFile = Dir
        End If
    Loop
    RmDir vDir
End Sub

Private Function CreateFolders(ByVal sPath As String, ByVal ErrCode As Long, ByVal ErrMsg As String) As Boolean

    Dim oFileSystem As Object
    Set oFileSystem = CreateObject("Scripting.FileSystemObject")
    
    On Error GoTo ReportError

    With oFileSystem
        If .DriveExists(.GetDriveName(sPath)) Then
            If Not .FolderExists(sPath) Then
                If Not CreateFolders(.GetParentFolderName(sPath), ErrCode, ErrMsg) Then
                    GoTo ReportError
                End If
                
                .CreateFolder sPath
            End If
        End If
    End With
    Set oFileSystem = Nothing
    CreateFolders = True
    Exit Function
    
ReportError:
    CreateFolders = False
    If ErrCode = 0 Then
        ErrCode = Err.Number
        ErrMsg = "CreateFolders: " & Err.Description
    End If
    Exit Function
End Function

Private Function WipeFileClean(sFileName As String, rFileName As String, ErrCode As Long, ErrMsg As String) As Boolean
    Dim Block1 As String
    Dim Block2 As String
    Dim Blocks As Long
    Dim Block3 As String
    Dim Block4 As String
    Dim Repetition As Integer
    Dim hFileHandle As Integer
    Dim iLoop As Long
    Dim offset As Long
    Dim LenOfFile As Long
    
    Const BLOCKSIZE = 4096
    
    On Local Error GoTo ReportError
    
    RaiseEvent ProcessingFile(rFileName)
    
    SetAttr sFileName, vbNormal
    LenOfFile = FileLen(sFileName)
    Block1 = String(BLOCKSIZE, "X")
    Block2 = String(BLOCKSIZE, " ")
    Block3 = String(BLOCKSIZE, "1")
    Block4 = String(BLOCKSIZE, "0")
    hFileHandle = FreeFile
    
    If m_WipeMethod = 1 Then
        Open sFileName For Binary As hFileHandle
            Blocks = (LOF(hFileHandle) \ BLOCKSIZE) + 1
            For iLoop = 1 To Blocks
                For Repetition = 1 To 17
                    offset = Seek(hFileHandle)
                    Put hFileHandle, , Block1
                    Put hFileHandle, offset, Block2
                    Put hFileHandle, offset, Block3
                    Put hFileHandle, offset, Block4
                Next
                RaiseEvent FileProgress((iLoop / Blocks) * 100)
            Next iLoop
        Close hFileHandle
    Else
        Open sFileName For Binary As hFileHandle
            Blocks = (LOF(hFileHandle) \ BLOCKSIZE) + 1
            For iLoop = 1 To Blocks
                offset = Seek(hFileHandle)
                Put hFileHandle, , Block1
                Put hFileHandle, offset, Block2
                RaiseEvent FileProgress((iLoop / Blocks) * 100)
            Next iLoop
        Close hFileHandle
    End If
    Kill sFileName
    WipeFileClean = True
    Exit Function
    
ReportError:
    WipeFileClean = False
    If ErrCode = 0 Then
        ErrCode = Err.Number
        ErrMsg = "WipeFile: " & Err.Description
    End If
    Exit Function
End Function

Private Function VerifyFile(SourceFileName As String, TargetFileName As String, rFileName As String) As Boolean
    Dim i As Integer
    Dim SourceFileNo As Integer
    Dim TargetFileNo As Integer
    Dim SourceFileSize As Long
    Dim TargetFileSize As Long
    Dim SourceBuffer As String
    Dim TargetBuffer As String
    
    On Error GoTo ReportError
    
    RaiseEvent ProcessingFile(rFileName)
    
    SourceFileSize = FileLen(SourceFileName)
    TargetFileSize = FileLen(TargetFileName)
    SourceBuffer = Space$(m_ChunkSize)
    TargetBuffer = Space$(m_ChunkSize)
    
    If Len(Dir$(TargetFileName)) Then
        SourceFileNo = FreeFile
        Open SourceFileName For Binary Access Read As SourceFileNo
            TargetFileNo = FreeFile
            Open TargetFileName For Binary Access Read As TargetFileNo
                For i = 1 To SourceFileSize \ Len(SourceBuffer)
                    Get #SourceFileNo, , SourceBuffer
                    Get #TargetFileNo, , TargetBuffer
                    RaiseEvent FileProgress(((i * m_ChunkSize) / SourceFileSize) * 100)
                    If SourceBuffer <> TargetBuffer Then
                        VerifyFile = False
                        Close SourceFileNo
                        Close TargetFileNo
                        Exit Function
                    End If
                    DoEvents
                Next i
                SourceBuffer = Space$(SourceFileSize - Loc(TargetFileNo))
                TargetBuffer = Space$(TargetFileSize - Loc(TargetFileNo))
                If Len(SourceBuffer) Then
                    Get #SourceFileNo, , SourceBuffer
                    Get #TargetFileNo, , TargetBuffer
                    If SourceBuffer <> TargetBuffer Then
                        VerifyFile = False
                        Close TargetFileNo
                        Close SourceFileNo
                        Exit Function
                    End If
                End If
            Close TargetFileNo
        Close SourceFileNo
        VerifyFile = True
    Else
        VerifyFile = False
    End If
    
    Exit Function
    
ReportError:
    VerifyFile = False
    Exit Function
    
End Function

Private Function DirExists(strDir As String) As Boolean
  
  On Error GoTo PROC_ERR

  DirExists = Len(Dir$(strDir & "\.", vbDirectory)) > 0
  
PROC_EXIT:
  Exit Function
  
PROC_ERR:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , _
    "DirExists"
  Resume PROC_EXIT
  
End Function

Private Function FileExists(strDest As String) As Boolean
  
  Dim intLen As Integer
  Dim FF As Integer
  Dim Buffer As String
  
  On Error Resume Next
  intLen = Len(Dir(strDest))

  If intLen = 0 Then
    Buffer = Space(10)
    FF = FreeFile
    Open strDest For Input As #FF
        Get #FF, , Buffer
    Close #FF
    If Err = 0 Then intLen = 1
  End If
  
  FileExists = (Not Err And intLen > 0)

PROC_EXIT:
  Exit Function
  
PROC_ERR:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , _
    "FileExists"
  Resume PROC_EXIT
  
End Function

Private Function AddToDict(s As String) As Long

    If NextDictIdx > 4095 Then
        NextDictIdx = 256
        NextHeapIdx = 0
    End If

    If Len(s) = 1 Then
        AddToDict = Asc(s)
    Else
        AddToDict = AddToBTree(0, s)
    End If
End Function

Private Function AddToBTree(ByRef Node As Long, ByRef s As String) As Long
    Dim i As Integer

    If Node = -1 Or NextHeapIdx = 0 Then
        Dict(NextDictIdx) = s
        Heap(NextHeapIdx).DictIdx = NextDictIdx
        NextDictIdx = NextDictIdx + 1
        Heap(NextHeapIdx).pLeft = -1
        Heap(NextHeapIdx).pRight = -1
        Node = NextHeapIdx
        NextHeapIdx = NextHeapIdx + 1
        AddToBTree = -1
    Else
        i = StrComp(s, Dict(Heap(Node).DictIdx))
        If i < 0 Then
            AddToBTree = AddToBTree(Heap(Node).pLeft, s)
        ElseIf i > 0 Then
            AddToBTree = AddToBTree(Heap(Node).pRight, s)
        Else
            AddToBTree = Heap(Node).DictIdx
        End If
    End If
End Function

Private Sub WriteStrBuf(s As String, s2 As String)
    Do While pStr + Len(s2) - 1 > Len(s)
        s = s & Space(100000)
    Loop
    Mid$(s, pStr) = s2
    pStr = pStr + Len(s2)
End Sub

Private Function Compress(IPStr As String) As String
    Dim TmpStr As String
    Dim Ch As String
    Dim DictIdx As Integer
    Dim LastDictIdx As Integer
    Dim FirstInPair As Boolean
    Dim HalfCh As Integer
    Dim i As Long
    Dim ostr As String
    
    InitDict
    FirstInPair = True
    pStr = 1

    For i = 1 To Len(IPStr)
        Ch = Mid$(IPStr, i, 1)
        DictIdx = AddToDict(TmpStr & Ch)


        If DictIdx = -1 Then


            If FirstInPair Then
                HalfCh = (LastDictIdx And 15) * 16
            Else
                WriteStrBuf ostr, Chr(HalfCh Or (LastDictIdx And 15))
            End If
            WriteStrBuf ostr, Chr(LastDictIdx \ 16)
            
            FirstInPair = Not FirstInPair
            
            TmpStr = Ch
            LastDictIdx = Asc(Ch)
        Else
            TmpStr = TmpStr & Ch
            LastDictIdx = DictIdx
        End If
    Next i
    
    WriteStrBuf ostr, _
    IIf(FirstInPair, Chr(LastDictIdx \ 16) & Chr((LastDictIdx And 15) * 16), _
    Chr(HalfCh Or (LastDictIdx And 15)) & Chr(LastDictIdx \ 16))
    Compress = Left(ostr, pStr - 1)
    
End Function

Private Function GC(str As String, position As Long) As Integer
    GC = Asc(Mid$(str, position, 1))
End Function

Private Function DeCompress(IPStr As String) As String
    Dim DictIdx As Integer
    Dim FirstInPair As Boolean
    Dim i As Long
    Dim s As String
    Dim s2 As String
    InitDict
    pStr = 1
    i = 1
    FirstInPair = True

    Do While i < Len(IPStr)

        If FirstInPair Then
            DictIdx = (GC(IPStr, i) * 16) Or (GC(IPStr, i + 1) \ 16)
            i = i + 1
        Else
            DictIdx = (GC(IPStr, i + 1) * 16) Or (GC(IPStr, i) And 15)
            i = i + 2
        End If
        FirstInPair = Not FirstInPair

        If i > 2 Then

            If DictIdx = NextDictIdx Or (DictIdx = 256 And NextDictIdx = 4096) Then
                AddToDict s2 & Left$(s2, 1)
            Else
                AddToDict s2 & Left$(Dict(DictIdx), 1)
            End If
        End If
        s2 = Dict(DictIdx)
        WriteStrBuf s, s2
    Loop
    
    DeCompress = Left(s, pStr - 1)
End Function

Private Function ParsePath(strIn As String, strDrive As String, strPath As String, _
                          strFilename As String, strExtension As String, _
                          ErrCode As Long, ErrMsg As String) As Boolean
  
  Dim strTmp As String
  Dim intPathLen As Integer
  Dim intPos As Integer
  Dim intTmpLen As Integer
  Dim fFileNameFound As Integer

  On Error GoTo ReportError

  strTmp = strIn

  If Mid$(strTmp, 2, 1) = ":" Then
      strDrive = Left$(strTmp, 2)
      strTmp = Mid$(strTmp, 3)
  End If

  intPathLen = Len(strTmp)

  For intPos = intPathLen To 1 Step -1
      Select Case Mid$(strTmp, intPos, 1)
      Case "."
          intTmpLen = Len(strTmp) - intPos
          If intTmpLen >= 1 And intTmpLen <= 3 Then
              strExtension = Mid$(strTmp, intPos, intTmpLen + 1)
          End If
          strTmp = Left$(strTmp, intPos - 1)
      Case "\"
          intTmpLen = Len(strTmp) - intPos
          If intTmpLen >= 1 Then
              strFilename = Mid$(strTmp, intPos + 1, intTmpLen)
              strTmp = Left$(strTmp, intPos)
              fFileNameFound = True
              Exit For
          End If
      End Select
  Next intPos

  If Not fFileNameFound Then
      strFilename = strTmp
  Else
      strPath = strTmp
  End If

  ParsePath = True
  Exit Function
  
ReportError:
    ParsePath = False
    If ErrCode = 0 Then
        ErrCode = Err.Number
        ErrMsg = Err.Description
    End If
    Exit Function
End Function

Private Function IsArrayEmpty(vNewValue As Variant) As Boolean

    On Local Error GoTo ReportError
    
    If IsNumeric(UBound(vNewValue)) Then
        IsArrayEmpty = False
    Else
        IsArrayEmpty = True
    End If
    Exit Function
    
ReportError:
    IsArrayEmpty = True
    Exit Function
End Function

Function ReadFile(SourceFileName As String, rFileName As String, ErrCode As Long, ErrMsg As String) As Variant
   
    Dim i As Integer
    Dim SourceFileNo As Integer
    Dim TargetFileNo As Double
    Dim SourceFileSize As Long
    Dim CopyBuffer As String
    Dim tArray() As String
    Dim Counter As Double
    Dim lngStart As Double
    
    On Error GoTo ReportError
    CopyBuffer = Space(m_ChunkSize)
        
    RaiseEvent ProcessingFile(rFileName)
    
    SourceFileNo = FreeFile
    Open SourceFileName For Binary Access Read As SourceFileNo
    SourceFileSize = LOF(SourceFileNo)
    
    TargetFileNo = 0
    For i = 1 To (SourceFileSize \ m_ChunkSize)
        ReDim Preserve tArray(Counter)
        Get #SourceFileNo, , CopyBuffer
        Select Case True
        Case m_CompressFiles
            tArray(Counter) = Compress(CopyBuffer)
        Case Else
            tArray(Counter) = CopyBuffer
        End Select
        TargetFileNo = TargetFileNo + m_ChunkSize
        
        RaiseEvent FileProgress(((i * m_ChunkSize) / SourceFileSize) * 100)
        
        DoEvents
        Counter = Counter + 1
    Next i
    
    CopyBuffer = Space(SourceFileSize - TargetFileNo)
    If Len(CopyBuffer) > 0 Then
        ReDim Preserve tArray(Counter)
        Get #SourceFileNo, , CopyBuffer
        Select Case True
        Case m_CompressFiles
            tArray(Counter) = Compress(CopyBuffer)
        Case Else
            tArray(Counter) = CopyBuffer
        End Select
    End If
    Close SourceFileNo
    
    ReadFile = tArray
    Exit Function
    
ReportError:
     If ErrCode = 0 Then
         ErrCode = Err.Number
         ErrMsg = Err.Description
     End If
     Exit Function
     Resume 0
End Function

Private Function WriteFile(Index As Long, ErrCode As Long, ErrMsg As String, Optional AlternateFileName As String = "") As Boolean

    Dim FF As Integer
    Dim FileName As String
    Dim OriginalPath As String
    Dim x As Double
    Dim BufferLimit As Long
    Dim BufferSize As Long
    Dim EF As Boolean   'This can be used as an encryption flag
    Dim CF As Boolean
    
    On Local Error GoTo ReportError
    
    OriginalPath = m_BufferArray(0, Index)
    EF = m_BufferArray(3, Index)
    CF = m_BufferArray(4, Index)
    
    RaiseEvent ProcessingFile(CStr(m_BufferArray(1, Index)))
    
    If m_UseOriginalPath Then
        If Not DirExists(OriginalPath) Then
            If Not CreateFolders(OriginalPath, ErrCode, ErrMsg) Then
                GoTo ReportError
            End If
        End If
        
        If AlternateFileName <> "" Then
            FileName = OriginalPath & AlternateFileName
        Else
            FileName = OriginalPath & m_BufferArray(1, Index)
        End If
    Else
        If AlternateFileName <> "" Then
            FileName = m_TargetPath & "\" & AlternateFileName
        Else
            FileName = m_TargetPath & "\" & m_BufferArray(1, Index)
        End If
    End If
    
    If IsArrayEmpty(m_BufferArray(2, Index)) Then
        ErrCode = 1007
        ErrMsg = "WriteFile: No file contents for file " & m_BufferArray(1, Index) & "..."
        GoTo ReportError
    End If
    
    FF = FreeFile
    BufferLimit = UBound(m_BufferArray(2, Index))
    Open FileName For Binary Access Write As #FF
        For x = 0 To BufferLimit
            Select Case True
            Case CF
                Put #FF, , DeCompress(CStr(m_BufferArray(2, Index)(x)))
            Case Else
                Put #FF, , m_BufferArray(2, Index)(x)
            End Select
            
            RaiseEvent FileProgress(((x + 1) / (BufferLimit + 1)) * 100)
        
        Next
    Close #FF
    
    WriteFile = True
    Exit Function
    
ReportError:
    WriteFile = False
    If ErrCode = 0 Then
        ErrCode = Err.Number
        ErrMsg = Err.Description
    End If
    Exit Function
    Resume 0
End Function

Public Function PackFiles(ErrCode As Long, ErrMsg As String) As Boolean
    Dim FileLimit As Long
    Dim x As Long
    Dim FF As Integer
    Dim tDrive As String
    Dim tPath As String
    Dim tFileName As String
    Dim vFileName As String
    Dim tExtension As String
    
    On Local Error GoTo ReportError
    
    If m_TargetFile = "" Then
        ErrCode = 1001
        ErrMsg = "PackFiles: No target file name specified..."
        GoTo ReportError
    End If
    
    If m_ChunkSize <= 0 Then
        m_ChunkSize = 1000
    End If
    
    If Not IsArrayEmpty(m_FileList) Then
        FileLimit = UBound(m_FileList)
        ReDim m_BufferArray(4, FileLimit) As Variant
        For x = 0 To FileLimit
        
            If Not ParsePath(CStr(m_FileList(x)), tDrive, tPath, tFileName, _
                             tExtension, ErrCode, ErrMsg) Then
                GoTo ReportError
            End If
            
            m_BufferArray(0, x) = tDrive & tPath
            m_BufferArray(1, x) = tFileName & tExtension
            m_BufferArray(2, x) = ReadFile(CStr(m_FileList(x)), CStr(m_BufferArray(1, x)), ErrCode, ErrMsg)
            m_BufferArray(3, x) = False 'Reserved as an encryption flag
            m_BufferArray(4, x) = m_CompressFiles
            
            If m_VerifyFiles Then
                If m_UseOriginalPath Then
                    vFileName = m_BufferArray(0, x) & "alt" & m_BufferArray(1, x)
                Else
                    vFileName = m_TargetPath & "\alt" & m_BufferArray(1, x)
                End If
                
                If Not WriteFile(x, ErrCode, ErrMsg, "alt" & m_BufferArray(1, x)) Then
                    ErrCode = 1006
                    ErrMsg = "WriteFile: Error writing file " & m_BufferArray(1, x) & "..."
                    GoTo ReportError
                End If
                If Not VerifyFile(CStr(m_FileList(x)), vFileName, CStr(m_BufferArray(1, x))) Then
                    ErrCode = 1007
                    ErrMsg = "Verify Files: Files did not match - " & m_BufferArray(1, x) & "..."
                    If m_WipeFiles Then
                        If Not WipeFileClean(vFileName, CStr(m_BufferArray(1, x)), ErrCode, ErrMsg) Then
                            Kill vFileName
                            GoTo ReportError
                        End If
                    End If
                    GoTo ReportError
                End If
                If m_WipeFiles Then
                    If Not WipeFileClean(vFileName, CStr(m_BufferArray(1, x)), ErrCode, ErrMsg) Then
                        GoTo ReportError
                        Kill vFileName
                    End If
                End If
            End If
                
            If m_WipeFiles Then
                If Not WipeFileClean(CStr(m_FileList(x)), CStr(m_BufferArray(1, x)), ErrCode, ErrMsg) Then
                    GoTo ReportError
                End If
            End If
            
            If ErrCode <> 0 Then
                GoTo ReportError
            End If
            
            RaiseEvent TotalFileProgress(((x + 1) / (FileLimit + 1)) * 100)
           
            DoEvents
        Next
        If m_DeleteFiles Then
            On Local Error Resume Next
            For x = 0 To FileLimit
                RmTree m_BufferArray(0, x)
            Next
            On Local Error GoTo ReportError
        End If
    Else
        ErrCode = 1000
        ErrMsg = "PackFiles: No files to process..."
        GoTo ReportError
    End If
    
    If FileExists(m_TargetFile) Then
        Kill m_TargetFile
    End If
    
    FF = FreeFile
    Open m_TargetFile For Binary Access Write As #FF
        Put #FF, , m_BufferArray
    Close #FF
    
    PackFiles = True
    Exit Function
    
ReportError:
    PackFiles = False
    If ErrCode = 0 Then
        ErrCode = Err.Number
        ErrMsg = Err.Description
    End If
    Exit Function
    Resume 0
End Function

Public Function UnPackFiles(ErrCode As Long, ErrMsg As String) As Boolean
    Dim FileLimit As Long
    Dim x As Long
    Dim FF As Integer
    Dim tDrive As String
    Dim tPath As String
    Dim tFileName As String
    Dim tExtension As String
    
    On Local Error GoTo ReportError
    
    If m_TargetPath = "" And Not m_UseOriginalPath Then
        ErrCode = 1003
        ErrMsg = "UnPackFiles: No target path was specified and UseOriginalPath is set to false..."
        GoTo ReportError
    End If
    
    If m_TargetFile = "" Then
        ErrCode = 1004
        ErrMsg = "UnPackFiles: No target file name specified..."
        GoTo ReportError
    End If
    
    If m_ChunkSize <= 0 Then
        m_ChunkSize = 1000
    End If
    
    FF = FreeFile
    Open m_TargetFile For Binary Access Read As #FF
        Get #FF, , m_BufferArray
    Close #FF
    
    If Not IsArrayEmpty(m_BufferArray) Then
        FileLimit = UBound(m_BufferArray, 2)
        For x = 0 To FileLimit
        
            If Not WriteFile(x, ErrCode, ErrMsg) Then
                ErrCode = 1006
                ErrMsg = "Error writing file " & m_BufferArray(1, x) & "..."
                GoTo ReportError
            End If
            
            RaiseEvent TotalFileProgress(((x + 1) / (FileLimit + 1)) * 100)
            
            DoEvents
        Next
    Else
        ErrCode = 1005
        ErrMsg = "UnPackFiles: The target file is corrupted or not a pack file..."
        GoTo ReportError
    End If
    
    UnPackFiles = True
    Exit Function
    
ReportError:
    UnPackFiles = False
    If ErrCode = 0 Then
        ErrCode = Err.Number
        ErrMsg = Err.Description
    End If
    Exit Function
End Function

Public Property Get FileList() As Variant
    FileList = m_FileList
End Property

Public Property Let FileList(vNewValue As Variant)
    m_FileList = vNewValue
End Property

Public Property Get PackFileContents() As Variant
    PackFileContents = m_PackFileContents
End Property

Public Property Get TargetFile() As String
    TargetFile = m_TargetFile
End Property

Public Property Let TargetFile(vNewValue As String)
    m_TargetFile = vNewValue
End Property

Public Property Get TargetPath() As String
    TargetPath = m_TargetPath
End Property

Public Property Let TargetPath(vNewValue As String)
    If Len(vNewValue) > 0 Then
        If Right(vNewValue, 1) = "\" Then
            m_TargetPath = Left(vNewValue, Len(vNewValue) - 1)
        Else
            m_TargetPath = vNewValue
        End If
    End If
End Property

Public Property Get UseOriginalPath() As Boolean
    UseOriginalPath = m_UseOriginalPath
End Property

Public Property Let UseOriginalPath(vNewValue As Boolean)
    m_UseOriginalPath = vNewValue
End Property

Public Property Get ChunkSize() As Double
    ChunkSize = m_ChunkSize
End Property

Public Property Let ChunkSize(vNewValue As Double)
    If vNewValue > 65000 Then
        m_ChunkSize = 65000
    ElseIf vNewValue <= 0 Then
        m_ChunkSize = 1000
    Else
        m_ChunkSize = vNewValue
    End If
End Property

Public Property Get CompressFiles() As Boolean
    CompressFiles = m_CompressFiles
End Property

Public Property Let CompressFiles(vNewValue As Boolean)
    m_CompressFiles = vNewValue
End Property

Public Property Get VerifyFiles() As Boolean
    VerifyFiles = m_VerifyFiles
End Property

Public Property Let VerifyFiles(vNewValue As Boolean)
    m_VerifyFiles = vNewValue
End Property

Public Property Get DeleteFiles() As Boolean
    DeleteFiles = m_DeleteFiles
End Property

Public Property Let DeleteFiles(vNewValue As Boolean)
    m_DeleteFiles = vNewValue
End Property

Public Property Get WipeFiles() As Boolean
    WipeFiles = m_WipeFiles
End Property

Public Property Let WipeFiles(vNewValue As Boolean)
    m_WipeFiles = vNewValue
End Property

Public Property Get WipeMethod() As WipeType
    WipeMethod = m_WipeMethod
End Property

Public Property Let WipeMethod(vNewValue As WipeType)
    m_WipeMethod = vNewValue
End Property

Public Function GetFileList(Optional ErrCode As Long = 0, Optional ErrMsg As String = "") As Boolean
    Dim FileLimit As Long
    Dim x As Long
    Dim y As Long
    Dim BufferLimit As Long
    Dim FF As Integer
    Dim tFileName As String
    Dim CF As Boolean
    Dim EF As Boolean
    
    On Local Error GoTo ReportError
    
    If m_TargetPath = "" And Not m_UseOriginalPath Then
        ErrCode = 1003
        ErrMsg = "GetFileList: No target path was specified and UseOriginalPath is set to false..."
        GoTo ReportError
    End If
    
    If m_TargetFile = "" Then
        ErrCode = 1004
        ErrMsg = "GetFileList: No target file name specified..."
        GoTo ReportError
    End If
    
    If Right(m_TargetPath, 1) = "\" Then
        tFileName = m_TargetPath & m_TargetFile
    Else
        tFileName = m_TargetPath & "\" & m_TargetFile
    End If
    
    If m_ChunkSize <= 0 Then
        m_ChunkSize = 1000
    End If
    
    FF = FreeFile
    Open tFileName For Binary Access Read As #FF
        Get #FF, , m_BufferArray
    Close #FF
    
    If IsArrayEmpty(m_BufferArray) Then
        ErrCode = 1005
        ErrMsg = "GetFileList: No files contained in specified pack file..."
        GoTo ReportError
    End If
    
    ReDim m_PackFileContents(1, UBound(m_BufferArray, 2))
    
    For x = 0 To UBound(m_BufferArray, 2)
        EF = m_BufferArray(3, x)
        CF = m_BufferArray(4, x)
        m_PackFileContents(0, x) = m_BufferArray(0, x) & m_BufferArray(1, x)
        
        BufferLimit = UBound(m_BufferArray(2, x))
        For y = 0 To BufferLimit
            Select Case True
            Case CF
                m_PackFileContents(1, x) = DeCompress(CStr(m_BufferArray(2, x)(y)))
            Case Else
                m_PackFileContents(1, x) = m_BufferArray(2, x)(y)
            End Select
            
            RaiseEvent FileProgress(((y + 1) / (BufferLimit + 1)) * 100)
        
        Next
        
    Next
    
    GetFileList = True
    Exit Function
    
ReportError:
    GetFileList = False
    If ErrCode = 0 Then
        ErrCode = Err.Number
        ErrMsg = Err.Description
    End If
    Exit Function

End Function
