VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "View Pack File Example"
   ClientHeight    =   6240
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8760
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6240
   ScaleWidth      =   8760
   StartUpPosition =   2  'CenterScreen
   Begin VB.ListBox lstPkFiles 
      Height          =   2400
      Left            =   75
      TabIndex        =   4
      Top             =   1065
      Width           =   3105
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "Browse"
      Height          =   375
      Left            =   75
      TabIndex        =   2
      Top             =   105
      Width           =   1590
   End
   Begin VB.TextBox txtContents 
      Height          =   5115
      Left            =   3240
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   1
      Top             =   1065
      Width           =   5430
   End
   Begin VB.ListBox lstFiles 
      Height          =   2400
      Left            =   60
      TabIndex        =   0
      Top             =   3795
      Width           =   3120
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Files in Selected Pack File"
      Height          =   195
      Left            =   60
      TabIndex        =   7
      Top             =   3540
      Width           =   1860
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "File Contents"
      Height          =   195
      Left            =   3240
      TabIndex        =   6
      Top             =   795
      Width           =   915
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Available Pack Files"
      Height          =   195
      Left            =   105
      TabIndex        =   5
      Top             =   810
      Width           =   1425
   End
   Begin VB.Label lblPath 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  'Fixed Single
      Height          =   390
      Left            =   1740
      TabIndex        =   3
      Top             =   105
      Width           =   6900
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private cBrowse As New clsBrowse
Private cPackFiles As New clsPackFiles
Private cFileSearch As New clsFileSearch

Private m_Folder As String
Private m_FileList As Variant
Private m_Results As Variant
Private m_FileContents As Variant

Private Sub cmdBrowse_Click()
    Dim ErrCode As Long
    Dim ErrMsg As String
    Dim x As Long
    
    On Local Error GoTo ReportError
    
    m_Folder = lblPath.Caption
    If Not IsValidFolder(m_Folder) Then
        m_Folder = ""
    End If
    
    If Len(Trim(m_Folder)) = 0 Then
        cBrowse.Parent = Me.hWnd
        cBrowse.Title = "Browse for Pack Files"
        cBrowse.Browse
        m_Folder = cBrowse.Folder
    
        If Len(Trim(m_Folder)) = 0 Then
            ErrCode = 220000
            ErrMsg = "Browse was canceled."
            GoTo ReportError
        End If
        
    End If
        
    If Not IsValidFolder(m_Folder) Then
        ErrCode = 57429427
        ErrMsg = "Folder is not valid..."
        GoTo ReportError
    End If

    lblPath = m_Folder
    
    Screen.MousePointer = vbHourglass
    
    cFileSearch.FileRoot = m_Folder
    cFileSearch.FileNameExtension = "*.pak"
    cFileSearch.Recurse = True
    cFileSearch.List = True
    cFileSearch.SearchForFiles
    
    Screen.MousePointer = vbDefault
    
    m_Results = cFileSearch.FileList
    
    If IsArrayEmpty(m_Results) Then
        ErrCode = 1429852947
        ErrMsg = "No Easy Write files found..."
        GoTo ReportError
    End If
    
    For x = 0 To UBound(m_Results)
        lstPkFiles.AddItem GetNamePart(CStr(m_Results(x)))
    Next
    
    Screen.MousePointer = vbDefault
    
    Exit Sub
    
ReportError:
    Screen.MousePointer = vbDefault
    If ErrCode = 0 Then
        ErrCode = Err.Number
        ErrMsg = Err.Description
    End If
    MsgBox "Error: " & ErrCode & " - " & ErrMsg, vbCritical + vbOKOnly, "Error"
    Exit Sub
    Resume 0
End Sub

Private Function IsValidFolder(Folder As String) As Boolean
    
    On Local Error GoTo ReportError
    
    If Len(Trim(Folder)) = 0 Then
        GoTo ReportError
    End If
    
    If Len(Dir(Folder, vbDirectory)) > 0 Then
        IsValidFolder = True
    Else
        IsValidFolder = False
    End If
    Exit Function
    
ReportError:
    IsValidFolder = False
    Exit Function
End Function

Private Function IsArrayEmpty(tArray As Variant, Optional Dimension As Integer = 1) As Boolean
    
    On Local Error GoTo ReportError
    
    If IsNumeric(UBound(tArray, Dimension)) Then
        IsArrayEmpty = False
    Else
        IsArrayEmpty = True
    End If
    Exit Function
    
ReportError:
    IsArrayEmpty = True
    Exit Function
    
End Function

Public Function GetNamePart(strIn As String) As String
  
  Dim intCounter As Integer
  Dim strTmp As String

  On Error GoTo PROC_ERR
  
  For intCounter = Len(strIn) To 1 Step -1
    If Mid$(strIn, intCounter, 1) <> "\" Then
      strTmp = Mid$(strIn, intCounter, 1) & strTmp
    Else
      Exit For
    End If
  Next intCounter

  GetNamePart = strTmp
  
PROC_EXIT:
  Exit Function
  
PROC_ERR:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, vbSystemModal + vbOKOnly, _
    "GetNamePart"
  Resume PROC_EXIT

End Function

Private Sub lstFiles_Click()
    On Local Error Resume Next
    txtContents.Text = m_FileContents(1, lstFiles.ListIndex)
    On Local Error GoTo 0
End Sub

Private Sub lstPkFiles_Click()
    Dim x As Long
    Dim ErrCode As Long
    Dim ErrMsg As String
    
    cPackFiles.TargetPath = lblPath.Caption
    cPackFiles.TargetFile = lstPkFiles.List(lstPkFiles.ListIndex)
    If Not cPackFiles.GetFileList(ErrCode, ErrMsg) Then
        GoTo ReportError
    End If
    
    For x = 0 To UBound(cPackFiles.PackFileContents, 2)
        lstFiles.AddItem GetNamePart(CStr(cPackFiles.PackFileContents(0, x)))
    Next
    
    m_FileContents = cPackFiles.PackFileContents
    
    Exit Sub
ReportError:
    MsgBox "Error: " & ErrCode & " - " & ErrMsg, vbCritical + vbOKOnly, "Error"
    Exit Sub
End Sub
